Bump Standards-Version to 3.9.1.
[grml-crypt.git] / grml-crypt
1 #!/bin/bash
2 # Filename:      grml-crypt
3 # Purpose:       Program to format, mount and unmount encrypted devices/files
4 # Authors:       Michael Gebetsroither <gebi@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Don Jul 26 19:57:28 CEST 2007 [mika]
8 ################################################################################
9
10
11 ###
12 ### __INCLUDES
13 ###
14 . /etc/grml/sh-lib
15 #. /etc/grml/sysexits-sh
16
17
18
19 ###
20 ### __VARIABLES
21 ###
22
23 verbose_=0
24 DEV_MAPPER_="/dev/mapper"
25 CRYPTSETUP_="cryptsetup"
26 IS_IMAGE_='false'
27 SIZE_="10"
28 SIZE_SET_='false'
29 FSTYPE_="vfat"
30 TARGET_=""
31 VERIFY_PW_=""
32 MKFS_=""
33 DM_NAME_=""
34 DM_PATH_=""
35 ACTION_=""
36 DM_PREFIX_="grml-crypt_"
37 FORCE_='false'
38 FSCK_='false'
39 ENTROPY_SOURCE_='/dev/urandom'
40 OPTIMIZED_MODE_SET_='false'
41 OPTIMIZING_LEVEL_=0
42 CIPHER_SIZE_="256"
43 CIPHER_="aes-cbc-essiv:sha256"
44 ITERATION_TIME_="1000"
45 ADDITIONAL_CRYPTSETUP_ARGS_=""
46 READONLY_SET_='false'
47 ADDITIONAL_MOUNT_ARGS_=""
48 BATCH_MODE_="--batch-mode"
49 PV_='/usr/bin/pv'
50
51 ###
52 ### __FUNCTIONS
53 ###
54
55 function printUsage
56 {
57   cat <<EOT
58 Usage: "$PROG_NAME__" [OPTIONS] action <device/file> [mountpoint]
59
60 $PROG_NAME__ is a wrapper around cryptsetup with LUKS support to format a device
61
62 OPTIONS:
63    -s         size of the loop-filesystem to create, in MB (default=$SIZE_)
64    -t         type of filesystem (default=$FSTYPE_)
65    -r         read only mode (fully supported only by start)
66    -z         insecure mode, using /dev/zero for most of the initialisation (INSECURE!)
67    -o         optimised initialisation mode (should be as secure as the default but faster)
68    -y         verifies the passphrase by asking for it twice
69    -f         force file overwriting in format mode and/or disable confirmation dialog
70    -F         only for action start: run fsck before mounting the filesystem. Use fsck's -f option if given twice.
71    -m         additional arguments to mount
72    -v         verbose (show what is going on, v++)
73    -h         this help text
74
75 CRYPTSETUP FORMAT OPTIONS:
76    -S         cipher size, could be 128, 192 or 256 (default=$CIPHER_SIZE_)
77    -C         cipher, should be aes-plain for pre-2.6.10 (default=$CIPHER_)
78    -I         iteration time spend with PBKDF2 password  processing in seconds (default=$ITERATION_TIME_)
79    -A         additional arguments for cryptsetup (only supportet by format)
80
81 ACTIONS:
82    format  <device/file> [mountpoint]
83               Format a device or a file (is created with the given size if it
84               does not exist) with the given filesystem and mount it, if a
85               mountpoint was given.
86    start  <device/file> <mountpoint>
87               Mount the device/file in the mountpoint.
88    stop   <mountpoint>
89               Umount the given mountpoint (umount, luksClose, losetup -d)
90
91 EOT
92
93   isGrml && cat <<EOT
94 NOTICE:
95    losetup does _NOT_ work on unionfs => grml-crypt with a filesystem image does ONLY
96    work if the image is on a tmpfs (eg. in /home/grml or /tmp).
97
98 EOT
99
100 }
101
102
103 function getDMName
104 {
105   device_="${1##*/}"
106
107   # first trying normal devicename
108   tmp_="${DM_PREFIX_}${device_}"
109   if [ ! -e "$tmp_" ]; then
110     echo "$tmp_"
111     return 0
112   fi
113
114   # second trying uuid of luks
115   #uuid_=`execute "$CRYPTSETUP_ luksUUID $1"`
116   #if [[ $? == 0 ]]; then
117   #  echo "$prefix_$uuid_"
118   #  return 0
119   #fi
120   warn "could not create device-mapper name for $1"
121   return 1
122 }
123
124
125 function formatDevice
126 {
127   type_="$1"  # could be donothing or init
128   ret_=0
129   local ddcmd_="dd if=/dev/zero of=$DM_PATH_ bs=1M &>/dev/null"
130   if [[ -x "$PV_" && $verbose_ -ge 3 ]] ; then
131     ddcmd_="dd if=/dev/zero bs=1M 2>/dev/null | $PV_ | dd of=$DM_PATH_ bs=1M &>/dev/null"
132   fi
133
134   args_="$VERIFY_PW_ $BATCH_MODE_ --key-size $CIPHER_SIZE_ --cipher $CIPHER_ --iter-time $ITERATION_TIME_ $ADDITIONAL_CRYPTSETUP_ARGS_"
135   #args_=`echo "$args_" |tr -s ' '`
136   execute "$CRYPTSETUP_ $args_ luksFormat $TARGET_" warn || return 1
137
138   execute "$CRYPTSETUP_ luksOpen $TARGET_ $DM_NAME_" warn \
139     "could not open $DM_PATH_ to create a filesystem on it!" || return 1
140   if [[ $type_ == 'init' && $OPTIMIZED_MODE_SET_ == 'true' ]]; then
141     echo "finishing optimised initialisation (this could take some time)"
142     # FIXME
143     execute "$ddcmd_" # || \
144     #  warn "could not finish optimised initialisation properly"
145     ret_=$?
146     # cutted out because of no space left on device error :(
147     #if [[ $ret_ != 0 ]]; then
148     #  execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
149     #  return 1
150     #fi
151   fi
152
153   execute "$MKFS_ $DM_PATH_ >/dev/null" warn
154   if [[ $? != 0 ]]; then
155     execute "$CRYPTSETUP_ luksClose $DM_NAME_"
156     warn "could not create filesystem on $DM_PATH_" 1
157     return 1
158   else
159     echo "Successully created $FSTYPE_ on encrypted $TARGET_"
160     return 0
161   fi
162 }
163
164
165 function actionStart
166 {
167   ret_=0
168
169   # no mountpoint, by-by
170   if [[ "$MOUNT_POINT_" == "" ]]; then
171     printUsage
172     die 'no mountpoint given'
173   fi
174   if [ ! -d "$MOUNT_POINT_" ]; then
175     die "mountpoint $MOUNT_POINT_ does not exist"
176   fi
177   # removed due to unionfs problem isLuks does not work with filesystem images
178   # without losetup
179   #$CRYPTSETUP_ isLuks $TARGET_ || die "$TARGET_ is not a luks partition"
180
181   # TARGET (is/should be) a filesystem image
182   if [ ! -b "$TARGET_" ]; then
183     notice "Operating on a file"
184     isExistent "$TARGET_" die "image does not exist"
185     TARGET_=`findNextFreeLoop` || die "could not find a free loop device"
186
187     # TARGET_ is now /dev/loop<x>
188     execute "losetup $TARGET_ $ORIG_TARGET_" die
189   fi
190   cargs_=""
191   $READONLY_SET_ && cargs_='--readonly'
192   execute "$CRYPTSETUP_ $cargs_ luksOpen $TARGET_ $DM_NAME_" warn || execute "losetup -d $TARGET_" || \
193     die "could not luksOpen $TARGET_"
194   if [[ "$FSCK_" == "true" ]] ; then
195     execute "fsck -C $DM_PATH_" || die "fsck failed on $DM_PATH_"
196   elif [[ "$FSCK_" == "trueforce" ]] ; then
197     execute "fsck -f -C $DM_PATH_" || die "fsck failed on $DM_PATH_"
198   fi
199   margs_=""
200   $READONLY_SET_ && margs_='-r'
201   execute "mount $margs_ $ADDITIONAL_MOUNT_ARGS_ $DM_PATH_ $MOUNT_POINT_" die
202 }
203
204
205 function actionStop
206 {
207   mp_="$1"
208   ret_=0
209
210   isExistent "$mp_" die
211   tmp_=`realpath $mp_` || die "could not get realpath of $mp_"
212   dprint "realpath_=\"$tmp_\""
213
214   dm_path_=`mount |grep "$tmp_ "` || die "$tmp_ is not mounted"
215   dprint "dm_path_=\"$dm_path_\""
216   dm_path_=`echo $dm_path_ |awk '{print $1}'` || die "could not get devicemapper name for $tmp_"
217   dprint "dm_path_=\"$dm_path_\""
218
219   # check for symlinks
220   unset tmp_dm_path_
221   for dmapper in /dev/mapper/grml-crypt* ; do
222     link=$(readlink -f "$dmapper")
223     dprint "looping device mapper devices, dmapper=$dmapper => link=$link"
224     if [ "$link" = "$dm_path_" ] ; then
225       tmp_dm_path_="$dmapper"
226     fi
227   done
228
229   if [ -n "$tmp_dm_path_" ] ; then
230     dm_path_="$tmp_dm_path_"
231     unset tmp_dm_path_
232   fi
233
234   dm_name_="${dm_path_##*/}"
235   dprint "dm_name_=\"$dm_name_\""
236
237   dmsetup info $dm_name_ >/dev/null ||die "$dm_name_ is not active"
238   device_=`$CRYPTSETUP_ status $dm_name_ |awk '/device:/{print $2}'` || \
239     die "could not get underlying device of $dm_path_"
240   dprint "device_=\"$device_\""
241
242   execute "umount $dm_path_" die "could not unmount $device_"
243   execute "$CRYPTSETUP_ luksClose $dm_name_" die "could not close $dm_path_"
244   echo "$device_" |grep loop &>/dev/null && execute "losetup -d $device_" \
245     die "could not delete loop device $device_" || \
246     execute "losetup -d $device_ &>/dev/null" eprint "could not delete loop device $device_, \
247 this device possibly is not a loop device => maybe bogus error"
248   notice "$mp_ successfully unmountet/closed/deleted"
249 }
250
251 function yesDialog
252 {
253   msg_="$1"
254
255   echo "WARNING!" >&2
256   echo "========" >&2
257   echo -n "$msg_" >&2
258   echo -n " (type uppercase yes): " >&2
259   read input
260   if [[ $input == 'YES' ]]; then
261     return 0
262   fi
263
264   return 1
265 }
266
267 function actionFormat
268 {
269   IS_IMAGE_='false'
270   ret_=0
271   init_='init'
272   local ddcmd_
273
274   if (( $SIZE_ < 3 )); then
275     die "the minimum size of an encrypted luks partition should be 2"
276   fi
277
278   # TARGET (is/should be) a filesystem image
279   if [ ! -b "$TARGET_" ]; then
280     notice "Operating on a file"
281     IS_IMAGE_='true'
282     if [ -e "$TARGET_" ]; then
283       $FORCE_ || die "$TARGET_ does already exist"
284       warn "overwriting file $TARGET_"
285       init_='donothing'
286     else
287       echo -n "Initialising file with "
288       if [[ $OPTIMIZED_MODE_SET_ == 'true' ]]; then
289         echo "optimised SECURE mode"
290         execute "dd if=/dev/zero of=$TARGET_ bs=1M count=${SIZE_} &>/dev/null" \
291           die "could not initialise $TARGET_ with /dev/zero"
292       else
293         if [[ $ENTROPY_SOURCE_ == '/dev/zero' ]]; then
294           echo "INSERCURE mode"
295         else
296           echo "SECURE mode (taking /dev/urandom as source, this could take some time)"
297         fi
298         execute "dd if=$ENTROPY_SOURCE_ of=$TARGET_ bs=1M count=${SIZE_} &>/dev/null" ||\
299           die "could not initialise $TARGET_ with $ENTROPY_SOURCE_"
300       fi
301     fi
302
303     TARGET_=`findNextFreeLoop` || die "could not find a free loop device"
304
305     # TARGET_ is now /dev/loop<x>
306     execute "losetup $TARGET_ $ORIG_TARGET_" die
307     if [[ $OPTIMIZED_MODE_SET_ == 'true' || $ENTROPY_SOURCE_ == '/dev/zero' ]]; then
308       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" \
309       die "could not initialise the fist 2MB of $TARGET_ with /dev/urandom"
310     fi
311     formatDevice "$init_"
312     ret_=$?
313   else
314     $FORCE_ || (yesDialog "Are you shure you want to overwrite $TARGET_ ?" || die 'You are not sure')
315     notice 'Operating on a device'
316     echo -n 'Initialising device with '
317     if [[ $OPTIMIZED_MODE_SET_ == 'true' ]]; then
318       echo "optimised SECURE mode"
319       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" ||\
320         die "could not initialise the first 2MB of $TARGET_ with /dev/urandom"
321     elif [[ $ENTROPY_SOURCE_ != '/dev/zero' ]]; then
322       # default mode
323       echo "SECURE mode (taking $ENTROPY_SOURCE_ as source, this could take some time)"
324       ddcmd_="dd if=$ENTROPY_SOURCE_ of=$TARGET_ bs=1M &>/dev/null"
325       if [[ -x "$PV_" && $verbose_ -ge 3 ]] ; then
326         ddcmd_="dd if=$ENTROPY_SOURCE_ bs=1M 2>/dev/null | $PV_ | dd of=$TARGET_ bs=1M &>/dev/null"
327       fi
328       execute "$ddcmd_" # ||\
329         # skipped because "no space left on device" from dd
330         # die "could not initialise $TARGET_ with $ENTROPY_SOURCE_"
331     else
332       echo 'INSECURE mode (only initialising the fist 2MB with /dev/urandom)'
333       execute "dd if=/dev/urandom of=$TARGET_ bs=1M count=2 &>/dev/null" \
334         die "could not initialise the first 2MB of $TARGET_ with /dev/urandom"
335     fi
336
337     formatDevice "$init_"
338     ret_=$?
339   fi
340
341   # formatDevice was successfully
342   if (( $ret_ == 0 )); then
343     # a mountpoint was given (don't luksClose the device)
344     local mount_point_exists_='true'
345     test -d "$MOUNT_POINT_" || mount_point_exists_='false'
346
347     if [[ $MOUNT_POINT_ != "" && "$mount_point_exists_" == 'true' ]]; then
348       $READONLY_SET_ && margs_='-r'
349       execute "mount $margs_ $ADDITIONAL_MOUNT_ARGS_ $DM_PATH_ $MOUNT_POINT_" die
350     else
351       if [[ $MOUNT_POINT_ != "" ]]; then
352         $mount_point_exists_ || warn "mountpoint $MOUNT_POINT_ does not exist, not mounting. please use \"grml-crypt start $ORIG_TARGET_ <mountpoint>\" to start the device"
353       fi
354       execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
355       $IS_IMAGE_ && execute "losetup -d $TARGET_" warn
356     fi
357   else
358     execute "$CRYPTSETUP_ luksClose $DM_NAME_" warn
359     $IS_IMAGE_ && execute "losetup -d $TARGET_" warn
360   fi
361 }
362
363
364
365 ###
366 ### __MAIN
367 ###
368
369 while getopts "s:t:rzoyfFm:hvS:C:I:A:" opt; do
370   case "$opt" in
371     s) SIZE_="$OPTARG"; SIZE_SET_='true' ;;
372     t) FSTYPE_="$OPTARG" ;;
373     r) READONLY_SET_='true' ;;
374     z) let OPTIMIZING_LEVEL_=$OPTIMIZING_LEVEL_+1
375         ENTROPY_SOURCE_='/dev/zero'
376         warn 'initialising from INSECURE source /dev/zero' ;;
377     o) let OPTIMIZING_LEVEL_=$OPTIMIZING_LEVEL_+1
378         OPTIMIZED_MODE_SET_='true' ;;
379     y) VERIFY_PW_="--verify-passphrase" ;;
380     f) FORCE_='true' ;;
381     F) if [[ "$FSCK_" == "true" ]] ; then
382          FSCK_='trueforce'
383        else
384          FSCK_='true'
385        fi
386       ;;
387     m) ADDITIONAL_MOUNT_ARGS_="$OPTARG" ;;
388     h) printUsage; exit ;;
389     v) let verbose_=$verbose_+1 ;;
390     S) CIPHER_SIZE_="$OPTARG" ;;
391     C) CIPHER_="$OPTARG" ;;
392     I) ITERATION_TIME_="$OPTARG" ;;
393     A) ADDITIONAL_CRYPTSETUP_ARGS_="$OPTARG" ;;
394     ?) printUsage; exit 64 ;;
395   esac
396 done
397 shift $(($OPTIND - 1))  # set ARGV to the first not parsed commandline parameter
398 setVerbose $verbose_
399
400 checkRoot die "You have to be root to use this program"
401 disableSyslog
402
403 if [[ $1 == 'help' ]]; then
404   printUsage
405   exit 0
406 fi
407 if (( $# < 2 )); then
408   printUsage
409   die "wrong number of arguments ($#)" 1
410 fi
411 if (( $OPTIMIZING_LEVEL_ > 1 )); then
412   printUsage
413   die "please choose ONE initialisation methode"
414 fi
415 TARGET_="$2"
416
417 MKFS_="/sbin/mkfs.$FSTYPE_"
418 if [ ! -x "$MKFS_" ]; then
419   die "invalid filesystem type \"$FSTYPE_\"" 1
420 fi
421
422 # use batch-mode if available
423 $CRYPTSETUP_ $BATCH_MODE_ --help &>/dev/null;
424 ret_=$?
425 case "$ret_" in
426   0)  dprint "your cryptsetup understands --batch-mode" ;;
427   1)  BATCH_MODE_=""; notice "your cryptsetup does NOT understand --batch-mode, trying without" ;;
428   127)  die "could not execute cryptsetup" 127 ;;
429   *)  warn "problems executing $CRYPTSETUP_" $ret_
430 esac
431
432 DM_NAME_="`getDMName $TARGET_`"
433 DM_PATH_="$DEV_MAPPER_/$DM_NAME_"
434 ORIG_TARGET_="$TARGET_"
435 MOUNT_POINT_="$3"
436
437 case "$1" in
438   format) ACTION_='format'; actionFormat ;;
439   start)  ACTION_='start'; actionStart ;;
440   stop)  ACTION_='stop'; actionStop "$TARGET_" ;;
441   *)  printUsage ;;
442 esac
443
444 # END OF FILE
445 ################################################################################
446 # vim:foldmethod=marker tabstop=2 expandtab shiftwidth=2